<?php

if (!class_exists('ICCard_Payment_Helper'))
{
	class ICCard_Payment_Helper
	{
		public function __construct($terminal = '')
		{
			$this->terminal = $terminal;
		}
		public function paymentRequest($data)
		{
			$result = $this->curl('https://service.iccard.ir/internetpaymentgateway', array(
					'terminalid'  => $this->terminal?:$data['terminal'],
					'callbackurl' => $data['callback'],
					'amount'      => $data['amount'],
					'invoiceid'   => (isset($data['order_id'])&&$data['order_id']?$data['order_id']:time()),
					'payload'     => (isset($data['description'])?$data['description']:'')
				));
			if (is_object($result) && isset($result->status)) {
				if ($result->status == 0) {
					return $this->token = $result->token;
				} else {
					$this->error = $result->message;
				}
			} else {
				$this->error = 'خطا در ارتباط با درگاه کارت اعتباری ایرانیان';
			}
			return false;
		}
		public function paymentVerify($data)
		{
			if ($data['status'] == 0) {
				$result = $this->curl('https://service.iccard.ir/internetpaymentgateway/verify', $data);
				if (is_object($result) && isset($result->status)) {
					if ($result->status == 0) {
						return true;
					} else {
						$this->error = $result->message;
					}
				} else {
					$this->error = 'خطا در ارتباط با درگاه کارت اعتباری ایرانیان';
				}
			} else {
				$this->error = 'تراکنش توسط کاربر لغو شد';
			}
			return false;
		}
		public function redirect($auto_connect = false)
		{
			echo '<form name="frmICCardPayment" method="post" action="https://service.iccard.ir/internetpaymentgateway/pay/"><input type="hidden" name="token" value="'.$this->token.'" /><input type="submit" value="پرداخت" /></form>';
			if ($auto_connect) echo '<script>document.frmICCardPayment.submit();</script>';
		}
		public function curl($url, $data)
		{
			$ch = curl_init($url);
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
			curl_setopt($ch, CURLOPT_TIMEOUT, 10);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			$response = curl_exec($ch);
			curl_close($ch);
			return json_decode($response);
		}
	}
}
